; CAN RTL by Professor Nimnul // BYTEFALL Gr0uP
; All Rights Reserved, CopyLefted (c) by Professor Nimnul
;----------------------------------------------------------------------------
; byte     byte       byte
;<FIRST> [<SECOND>, [<FIRD>]]
;
;   FIRST
;   0..15 = New Foreground Color                 
;  16..23 = New Background Color
;      24 = CR/LF
;      25 = Displays <SECOND> number of spaces.
;      26 = Repeat <SECOND> number next byte     
;      27 = Toggles on/off the foreground attribute blink flag.
;      28 = Set Cursor <SECOND> <FIRD>
;      29 = Set Vert pozition if <SECOND> == <+> => Down , <-> = Down
;      30 = Set Horz pozition if <SECOND> == <+> => Right, <-> = Left
;      31 = Extended Code
;	 SECOND
;           0 = CLear Screen
;           1 = CLeaR till EOL
;           3 = Save Cursor
;           4 = Restore Cursor
;----------------------------------------------------------------------------

;DS:SI readed buffer
CANSHOW	proc
  
	mov	ah,ATTR      
LOOPA: 
	cmp	si,Readed
	ja	_Done

	LODSB                           ;Get next character.
        CMP     AL,32                   ;If a control character, jump.
        JC      ForeGround
        call	PrintCHAR		;Save letter on screen.
;----------------------------------------------------------------
Next:  	
	dec	word ptr _CX
	jg 	LOOPA
_Done:
        JMP     Done

ForeGround:
        CMP     AL,16                   
        JNC     BackGround              
        AND     AH,0F0H                 ;Strip off old foreground.
        OR      AH,AL
        JMP     Next
 
BackGround:
        CMP     AL,24                   
        JZ      NextLine                
        JNC     FlashBitToggle          

        SUB     AL,16                   
	shl	al,4

;        ADD     AL,AL                   
;        ADD     AL,AL
;        ADD     AL,AL
;        ADD     AL,AL

        AND     AH,8FH                  ;Strip off old background.
        OR      AH,AL

        JMP     Next

NextLine:
	pusha
	call	GetCursor
	CALL    GetMaxRow               ;25/30/40/50 rows now?
	cmp	al,dh
	jg	NoScroll

	PUSH	DX

	MOV     DH,AL                   
	MOV     DL,79
	XOR     CX,CX                   
	MOV     AX,601H
	MOV     BH,7			
	INT     10H

	POP	DX

	dec	byte ptr [CursPoz+1]
	DEC	dh

NoScroll:
	inc	dh

	mov	dl,0
	mov	bh,0
	mov	ah,2
	int	10h
EndNextLine:
	popa

        JMP     Next                    

FlashBitToggle:
        CMP     AL,27                   
        JC      MultiOutput             
        JNZ     ExtendedCmd
        XOR     AH,128                  
        JMP     Next

MultiOutput:
	dec	word ptr _CX
        CMP     AL,25                   
        LODSB                           
        MOV     CL,AL                   
        MOV     AL,32
        JZ      StartOutput             
        LODSB                           
	dec	word ptr _CX

StartOutput:
        XOR     CH,CH

RepeatPrint:
	call	PrintCHAR
	loop	RepeatPrint
;----------------------------------------------------------------
	jmp	Next

Done:
	mov	ATTR,ah  

       	RET

CANSHOW 	ENDP

;--------------------------------------------------------------
ExtendedCmd:
	mov	ATTR,ah

	cmp	al,28
	jne	l_1
SetCursor:
	lodsw
	sub	word ptr _CX,2
	xchg	ax,dx
_SetCursor:
	mov	bh,0
	mov	ah,2
	int	10h
	jmp	short l_4
l_1:
	cmp	al,29
	jne	l_2
SetVert:
	call	GetCursor
	lodsb
	sub	word ptr _CX,1
	add	dh,al
	jmp	short _SetCursor
l_2:
	cmp	al,30
	jne	l_3
SetHorz:
	call	GetCursor
	lodsb
	sub	word ptr _CX,1
	add	dl,al
	jmp	short _SetCursor
l_3:
	cmp	al,31
	jne	l_4
ExtendedCode:
	lodsb
	sub	word ptr _CX,1
	cmp	al,0
	jne	l_5
CLS:
	CALL    GetMaxRow               ;25/30/40/50 rows now?
	MOV     DH,AL                   
	MOV     DL,79
	XOR     CX,CX                   
	MOV     AX,600H
	MOV     BH,7	
	INT     10H
	XOR     DX,DX                   
	jmp	short _SetCursor
l_5:
	cmp	al,1
	jne	l_6
CLR:
	call	GetCursor
	MOV     CX,DX                   
	MOV     DL,79			; I THINK SO :)
	MOV     BH,ATTR
	MOV     AX,601H
	INT     10H
	jmp	short l_4
	
l_6:
	cmp	al,2
	jne	l_7
SaveCursor:
	call	GetCursor
	mov	CursPoz,dx
	jmp	short l_4
l_7:
	cmp	al,3
	jne	l_4
RestCursor:
	mov	dx,CursPoz
	jmp	short _SetCursor
;--------------------------------------------------------------
l_4:
	mov	ah,ATTR
	mov	cx,_CX

	JMP	Next
;--------------------------------------------------------------
; AL = CHAR
PrintCHAR	proc
	pusha

	cmp	al,13
	jz	TTY_PRINT 

	cmp	al,10
	ja      BIOS_PRINT
	cmp	al,7
	jnc	TTY_PRINT

BIOS_PRINT:
	mov	bl,ah	; Attr
	mov	ah,9
	mov	bh,0	; Page = 0
	mov	cx,1	; How write
	int	10h

TTY_PRINT:
	mov	bx,7
	mov	ah,0Eh
	int	10h

EndPrintCHAR:
	popa

	ret
PrintCHAR	endp
;--------------------------------------------------------------
GetCursor	proc
	mov	ah,3
	mov	bh,0
	int	10h
	ret
GetCursor	endp
;--------------------------------------------------------------
GetMaxRow	proc
   	PUSH    DS                      
        MOV     AX,40H                  
        MOV     DS,AX
        MOV     AL,DS:[84H]             
        OR      AL,AL                   
        JNZ     EndGetMaxRow            
        MOV     AL,24                   
EndGetMaxRow:      
	POP     DS
	RET
GetMaxRow	endp
;--------------------------------------------------------------
